<?php

namespace Sabre\QueueCount;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'QueueCountRQ' => '\\Sabre\\QueueCount\\Structs\\QueueCountRQ',
            'QueueInfo' => '\\Sabre\\QueueCount\\Structs\\QueueInfo',
            'QueueIdentifier' => '\\Sabre\\QueueCount\\Structs\\QueueIdentifier',
            'Range' => '\\Sabre\\QueueCount\\Structs\\Range',
            'Selection' => '\\Sabre\\QueueCount\\Structs\\Selection',
            'SabreHeader' => '\\Sabre\\QueueCount\\Structs\\SabreHeader',
            'DiagnosticResults' => '\\Sabre\\QueueCount\\Structs\\DiagnosticResults',
            'Diagnostics' => '\\Sabre\\QueueCount\\Structs\\Diagnostics',
            'Identification' => '\\Sabre\\QueueCount\\Structs\\Identification',
            'Identifier.System' => '\\Sabre\\QueueCount\\Structs\\Identifier_System',
            'Message.Condition' => '\\Sabre\\QueueCount\\Structs\\Message_Condition',
            'ProblemBase' => '\\Sabre\\QueueCount\\Structs\\ProblemBase',
            'ProblemSummary' => '\\Sabre\\QueueCount\\Structs\\ProblemSummary',
            'ResultSummary' => '\\Sabre\\QueueCount\\Structs\\ResultSummary',
            'Security' => '\\Sabre\\QueueCount\\Structs\\Security',
            'Service' => '\\Sabre\\QueueCount\\Structs\\Service',
            'Traces' => '\\Sabre\\QueueCount\\Structs\\Traces',
            'TraceRecord' => '\\Sabre\\QueueCount\\Structs\\TraceRecord',
            'TrackingID' => '\\Sabre\\QueueCount\\Structs\\TrackingID',
            'STL_Payload' => '\\Sabre\\QueueCount\\Structs\\STL_Payload',
            'Results' => '\\Sabre\\QueueCount\\Structs\\Results',
            'ApplicationResults' => '\\Sabre\\QueueCount\\Structs\\ApplicationResults',
            'ProblemInformation' => '\\Sabre\\QueueCount\\Structs\\ProblemInformation',
            'SystemSpecificResults' => '\\Sabre\\QueueCount\\Structs\\SystemSpecificResults',
            'HostCommand' => '\\Sabre\\QueueCount\\Structs\\HostCommand',
            'QueueCountRS' => '\\Sabre\\QueueCount\\Structs\\QueueCountRS',
            'AdditionalQueueInfo' => '\\Sabre\\QueueCount\\Structs\\AdditionalQueueInfo',
            'Totals' => '\\Sabre\\QueueCount\\Structs\\Totals',
            'SignatureType' => '\\Sabre\\QueueCount\\Structs\\SignatureType',
            'SignatureValueType' => '\\Sabre\\QueueCount\\Structs\\SignatureValueType',
            'SignedInfoType' => '\\Sabre\\QueueCount\\Structs\\SignedInfoType',
            'CanonicalizationMethodType' => '\\Sabre\\QueueCount\\Structs\\CanonicalizationMethodType',
            'SignatureMethodType' => '\\Sabre\\QueueCount\\Structs\\SignatureMethodType',
            'ReferenceType' => '\\Sabre\\QueueCount\\Structs\\ReferenceType',
            'TransformsType' => '\\Sabre\\QueueCount\\Structs\\TransformsType',
            'TransformType' => '\\Sabre\\QueueCount\\Structs\\TransformType',
            'DigestMethodType' => '\\Sabre\\QueueCount\\Structs\\DigestMethodType',
            'KeyInfoType' => '\\Sabre\\QueueCount\\Structs\\KeyInfoType',
            'KeyValueType' => '\\Sabre\\QueueCount\\Structs\\KeyValueType',
            'RetrievalMethodType' => '\\Sabre\\QueueCount\\Structs\\RetrievalMethodType',
            'X509DataType' => '\\Sabre\\QueueCount\\Structs\\X509DataType',
            'X509IssuerSerialType' => '\\Sabre\\QueueCount\\Structs\\X509IssuerSerialType',
            'PGPDataType' => '\\Sabre\\QueueCount\\Structs\\PGPDataType',
            'SPKIDataType' => '\\Sabre\\QueueCount\\Structs\\SPKIDataType',
            'ObjectType' => '\\Sabre\\QueueCount\\Structs\\ObjectType',
            'ManifestType' => '\\Sabre\\QueueCount\\Structs\\ManifestType',
            'SignaturePropertiesType' => '\\Sabre\\QueueCount\\Structs\\SignaturePropertiesType',
            'SignaturePropertyType' => '\\Sabre\\QueueCount\\Structs\\SignaturePropertyType',
            'DSAKeyValueType' => '\\Sabre\\QueueCount\\Structs\\DSAKeyValueType',
            'RSAKeyValueType' => '\\Sabre\\QueueCount\\Structs\\RSAKeyValueType',
            'Envelope' => '\\Sabre\\QueueCount\\Structs\\Envelope',
            'Header' => '\\Sabre\\QueueCount\\Structs\\Header',
            'Body' => '\\Sabre\\QueueCount\\Structs\\Body',
            'Fault' => '\\Sabre\\QueueCount\\Structs\\Fault',
            'detail' => '\\Sabre\\QueueCount\\Structs\\Detail',
            'Manifest' => '\\Sabre\\QueueCount\\Structs\\Manifest',
            'Reference' => '\\Sabre\\QueueCount\\Structs\\Reference',
            'Schema' => '\\Sabre\\QueueCount\\Structs\\Schema',
            'MessageHeader' => '\\Sabre\\QueueCount\\Structs\\MessageHeader',
            'MessageData' => '\\Sabre\\QueueCount\\Structs\\MessageData',
            'SyncReply' => '\\Sabre\\QueueCount\\Structs\\SyncReply',
            'MessageOrder' => '\\Sabre\\QueueCount\\Structs\\MessageOrder',
            'AckRequested' => '\\Sabre\\QueueCount\\Structs\\AckRequested',
            'Acknowledgment' => '\\Sabre\\QueueCount\\Structs\\Acknowledgment',
            'ErrorList' => '\\Sabre\\QueueCount\\Structs\\ErrorList',
            'Error' => '\\Sabre\\QueueCount\\Structs\\Error',
            'StatusResponse' => '\\Sabre\\QueueCount\\Structs\\StatusResponse',
            'StatusRequest' => '\\Sabre\\QueueCount\\Structs\\StatusRequest',
            'sequenceNumber.type' => '\\Sabre\\QueueCount\\Structs\\SequenceNumber_type',
            'PartyId' => '\\Sabre\\QueueCount\\Structs\\PartyId',
            'To' => '\\Sabre\\QueueCount\\Structs\\To',
            'From' => '\\Sabre\\QueueCount\\Structs\\From',
            'Description' => '\\Sabre\\QueueCount\\Structs\\Description',
            'UsernameToken' => '\\Sabre\\QueueCount\\Structs\\UsernameToken',
        );
    }
}
